
var Promise = require('native-or-bluebird')
var ffmpeg = require('fluent-ffmpeg')
var request = require('request')
var tmpdir = require('os').tmpdir()
var path = require('path')
var fs = require('fs')

module.exports = function (url) {
  var filename

  return new Promise(function (resolve, reject) {
    request(url)
    .on('error', reject)
    .on('response', function (res) {
      if (res.statusCode !== 200) {
        this.destroy()
        reject(new Error('Video does not exist!'))
        return
      }

      filename = path.resolve(tmpdir, Math.random().toString(36).slice(2))
      this.pipe(fs.createWriteStream(filename))
      .on('error', reject)
      .on('close', resolve)
    })
  }).then(function () {
    return new Promise(function (resolve, reject) {
      ffmpeg(filename).ffprobe(function (err, data) {
        if (err) return reject(err)
        resolve(data)
      })
    })
  }).then(function (data) {
    fs.unlink(filename, noop)
    return data
  }, function (err) {
    fs.unlink(filename, noop)
    throw err
  })
}

function noop() {}
